/* retr.c -- retrieves, cleans, and formats mail
 * $Id: retr.c,v 1.1 1996/04/08 15:49:50 gh Exp $
 */

/*
    Copyright (C) 1996 Robert Mark Waugh (rmw@io.com) 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include <string.h>

#include "pimp.h"

extern char *config;
extern int pop3_port;
extern char *spool;
extern int mail_grp;
extern char *rtime;

void 
retrieve_message (int sock, unsigned long length, FILE * spoolfd, char *rtime)
{
  char *mailbody, *mailbodyswaper;
  extern int probesocket (int sock, int seconds, int useconds);

  mailbody = get_data (sock, 3, 0);

  mailbody[strlen (mailbody) - 3] = '\0';
  if ((mailbodyswaper = strdup (strchr (mailbody, '\n'))) == NULL)
    /* error check */ ;
#ifdef DEBUG
  fprintf (stderr, "Swapped for tokening of mailbody:%i\n", elapsed ());
#endif
  free (mailbody);
  mailbody = mailbodyswaper;
  mailbodyswaper = format_mail (mailbody, rtime);

#ifdef DEBUG
  fprintf (stderr, "Writing this mail to spoolfd:%i\n", elapsed ());
#endif

  fprintf (spoolfd, "%s\n", mailbodyswaper);
  free (mailbodyswaper);
}

char *
format_mail (char *mailbody, char *rtime)
{


  char *strippedbuffer;

  char *index1, *index2, *index3, *index4;
  char *frombuffer, *addrbuffer;
  unsigned long offset;
  char *finalstring;

  strippedbuffer = malloc ((strlen (mailbody) * sizeof (char)));
#ifdef DEBUG
  fprintf (stderr, "Second duplication of mailbody for tokening:%i\n", elapsed ());
#endif

  index1 = mailbody;
  offset = 0;

  while (index1 != NULL)
    {
      if ((index2 = strchr (index1 + 1, '\r')) == NULL)
	break;
      *index2 = '\0';
      if (strippedbuffer[0] != '\0')
	{
	  strcpy (strippedbuffer + offset, index1);
	  offset = index2 - index1 + offset;
	}
      else
	{
	  strcpy (strippedbuffer + offset, index1);
	  offset = index2 - index1;
	}
      index1 = index2 + 1;
    }
  index1 = NULL;
  index2 = NULL;
#ifdef DEBUG
  fprintf (stderr, "Stripped all \\r's from mailbody:%i\n", elapsed ());
#endif
  free (mailbody);
  if (strstr (strippedbuffer, "Return-Path: ") == NULL)
    {
      index1 = (char *) malloc (strlen (strstr (strippedbuffer, "From: ")) * sizeof (char) + 1);
      strcpy (index1, strstr (strippedbuffer, "From: "));
    }
  else
    {
      index1 = (char *) malloc (strlen (strstr (strippedbuffer, "Return-Path: ")) * sizeof (char) + 1);
      strcpy (index1, strstr (strippedbuffer, "Return-Path: "));
    }
  index2 = strchr (index1, '\n');
  *index2 = '\0';
  if ((frombuffer = (char *) malloc (strlen (index1) * sizeof (char) + 2)) == NULL)
    {
      perror (NULL);
      exit (-1);
    }
  strcpy (frombuffer, index1);
  *index2 = '\n';

  if ((index3 = strchr (frombuffer, '<')) != NULL)
    {
      index3++;
      index4 = strchr (index3, '>');
      *index4 = '\0';
      addrbuffer = strdup (index3);
      *index4 = '>';
/*
   sprintf(frombuffer, "From %s ", addrbuffer);
 */
      strcpy (frombuffer, "From ");
      strcat (frombuffer, addrbuffer);
      strcat (frombuffer, " ");
    }
  else
    {
      frombuffer = (char *) realloc (frombuffer,
		 strlen ("From Poorly_formed_header ") * sizeof (char) + 1);
      strcpy (frombuffer, "From Poorly_formed_header ");
      addrbuffer = (char *) malloc (1);
    }
  finalstring = (char *) malloc ((strlen (strippedbuffer) + strlen (frombuffer) +
				  strlen (rtime) * sizeof (char)) + 5);
/*
   sprintf(finalstring, "%s %s%s", frombuffer, rtime, &strippedbuffer[1]);
 */
  strcpy (finalstring, frombuffer);
  strcat (finalstring, rtime);
  strcat (finalstring, &strippedbuffer[1]);
  free (frombuffer);
  free (index1);
  free (strippedbuffer);
  free (addrbuffer);
#ifdef DEBUG
#endif	/* DEBUG */
  return finalstring;
}
